package com.miaxis.gan.service;

import java.util.List;
import java.util.Map;

import com.miaxis.gan.domain.GanZhi;
import com.baomidou.mybatisplus.extension.service.IService;
import com.miaxis.gan.dto.GanZhiDto;
import com.miaxis.gan.vo.GanZhiFiveVo;
import com.miaxis.gan.vo.GanZhiKongWangVo;
import com.miaxis.gan.vo.GanZhiNaYinVo;
import com.miaxis.gan.vo.GanZhiRowVo;

/**
 * 天干地支Service接口
 *
 * @author miaxis
 * @date 2023-11-16
 */
public interface IGanZhiService extends IService<GanZhi>{
    /**
     * 查询天干地支列表
     *
     * @param ganZhi 天干地支
     * @return 天干地支集合
     */
    List<GanZhi> selectGanZhiList(GanZhi ganZhi);

    List<GanZhiRowVo> selectGanZhiRowVoList(GanZhiDto ganZhiDto);

    List<GanZhiNaYinVo> selectGanZhiNaYinList(GanZhiDto ganZhiDto);

    List<GanZhiKongWangVo> selectGanZhiKongWangList(GanZhiDto ganZhiDto);

    Integer getRiYuanQr(GanZhiDto ganZhiDto);

    Map<String,Integer> getGanZhiRowVoCount(GanZhiDto ganZhiDto);
}
