package com.miaxis.gan.service.impl;

import java.util.*;
import java.util.concurrent.atomic.AtomicBoolean;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.miaxis.common.config.ShiShenConfig;
import com.miaxis.gan.dto.GanZhiDto;
import com.miaxis.gan.vo.GanZhiFiveVo;
import com.miaxis.gan.vo.GanZhiKongWangVo;
import com.miaxis.gan.vo.GanZhiNaYinVo;
import com.miaxis.gan.vo.GanZhiRowVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.apache.commons.lang3.StringUtils;
import com.miaxis.gan.mapper.GanZhiMapper;
import com.miaxis.gan.domain.GanZhi;
import com.miaxis.gan.service.IGanZhiService;

/**
 * 天干地支Service业务层处理
 *
 * @author miaxis
 * @date 2023-11-16
 */
@Service
public class GanZhiServiceImpl extends ServiceImpl<GanZhiMapper, GanZhi> implements IGanZhiService {
    @Autowired
    private GanZhiMapper ganZhiMapper;

    @Autowired
    private ShiShenConfig shiShenConfig;

    /**
     * 查询天干地支列表
     *
     * @param ganZhi 天干地支
     * @return 天干地支
     */
    @Override
    public List<GanZhi> selectGanZhiList(GanZhi ganZhi) {
        return ganZhiMapper.selectGanZhiList(ganZhi);
    }

    @Override
    public List<GanZhiRowVo> selectGanZhiRowVoList(GanZhiDto ganZhiDto) {

        List<GanZhiRowVo> list = this.getGanZhiRowVoList(ganZhiDto);
        System.out.println(list);
        if (ganZhiDto.getSex() == 1) {
            list.get(4).setShiShen1("元男");
        } else if (ganZhiDto.getSex() == 2) {
            list.get(4).setShiShen1("元女");
        }

        /*-----------------------十神 开始-------------------*/
        for (int i = 0; i < list.size(); i++) {

            if ((i == 0 || i == 2 || i == 6) && i != 4) {

                String zhengYin = shiShenConfig.getZhengYin().get(list.get(i).getName()); //正印
                String shiShen = shiShenConfig.getShiShen().get(list.get(i).getName());  //食神
                String zhengGuan = shiShenConfig.getZhengGuan().get(list.get(i).getName()); //正官
                String zhengCai = shiShenConfig.getZhengCai().get(list.get(i).getName()); //正财
                String qiSha = shiShenConfig.getQiSha().get(list.get(i).getName());  //七杀
                String pianYin = shiShenConfig.getPianYin().get(list.get(i).getName()); //偏印
                String shangGuan = shiShenConfig.getShangGuan().get(list.get(i).getName()); // 伤官
                String jieCai = shiShenConfig.getJieCai().get(list.get(i).getName()); // 劫财
                String biJian = shiShenConfig.getBiJian().get(list.get(i).getName()); // 比肩
                String pianCai = shiShenConfig.getPianCai().get(list.get(i).getName()); // 偏财

                if (list.get(4).getName().equals(zhengYin)) { //比对出正印
                    list.get(i).setShiShen1("正印");
                }
                if (list.get(4).getName().equals(shiShen)) { //比对出食神
                    list.get(i).setShiShen1("食神");
                }
                if (list.get(4).getName().equals(zhengGuan)) { //比对出正官
                    list.get(i).setShiShen1("正官");
                }
                if (list.get(4).getName().equals(zhengCai)) { //比对出正财
                    list.get(i).setShiShen1("正财");
                }
                if (list.get(4).getName().equals(qiSha)) { //比对出七杀
                    list.get(i).setShiShen1("七杀");
                }
                if (list.get(4).getName().equals(pianYin)) { //比对出偏印
                    list.get(i).setShiShen1("偏印");
                }
                if (list.get(4).getName().equals(shangGuan)) { //比对出伤官
                    list.get(i).setShiShen1("伤官");
                }
                if (list.get(4).getName().equals(jieCai)) { //比对出劫财
                    list.get(i).setShiShen1("劫财");
                }
                if (list.get(4).getName().equals(biJian)) { //比对出比肩
                    list.get(i).setShiShen1("比肩");
                }
                if (list.get(4).equals(pianCai)) { //比对出偏财
                    list.get(i).setShiShen1("偏财");
                }

            }

            if ((i == 1 || i == 3 || i == 5 || i == 7) && i != 4) {   //地支

                String benQi = shiShenConfig.getBenQi().get(list.get(i).getName());    //戊
                String zhongQi = shiShenConfig.getZhongQi().get(list.get(i).getName()); //乙
                String yuQi = shiShenConfig.getYuQi().get(list.get(i).getName());   //癸

                /*------------------------正印--------------------------*/
                String zhengYinBenQi = (benQi != null) ? shiShenConfig.getZhengYin().get(benQi) : null; //正印本气
                String zhengYinZhongQi = (zhongQi != null) ? shiShenConfig.getZhengYin().get(zhongQi) : null; //正印中余
                String zhengYinYuQi = (yuQi != null) ? shiShenConfig.getZhengYin().get(yuQi) : null; //正印余气

                if (StringUtils.isNotEmpty(zhengYinBenQi) && list.get(4).getName().equals(zhengYinBenQi)) { //比对出正印
                    list.get(i).setShiShen1(benQi + "（正印）");
                }
                if (StringUtils.isNotEmpty(zhengYinZhongQi) && list.get(4).getName().equals(zhengYinZhongQi)) { //比对出正印
                    list.get(i).setShiShen2(zhongQi + "（正印）");
                }
                if (StringUtils.isNotEmpty(zhengYinYuQi) && list.get(4).getName().equals(zhengYinYuQi)) { //比对出正印
                    list.get(i).setShiShen3(yuQi + "（正印）");
                }


                /*------------------------食神-----------------------------*/
                String shiShenBenQi = (benQi != null) ? shiShenConfig.getShiShen().get(benQi) : null; //食神本气
                String shiShenZhongQi = (zhongQi != null) ? shiShenConfig.getShiShen().get(zhongQi) : null; //食神中气
                String shiShenYuQi = (yuQi != null) ? shiShenConfig.getShiShen().get(yuQi) : null; //食神余气

                if (StringUtils.isNotEmpty(shiShenBenQi) && list.get(4).getName().equals(shiShenBenQi)) { //比对出食神
                    list.get(i).setShiShen1(benQi + "（食神）");
                }
                if (StringUtils.isNotEmpty(shiShenZhongQi) && list.get(4).getName().equals(shiShenZhongQi)) { //比对出食神
                    list.get(i).setShiShen2(zhongQi + "（食神）");
                }
                if (StringUtils.isNotEmpty(shiShenYuQi) && list.get(4).getName().equals(shiShenYuQi)) { //比对出食神
                    list.get(i).setShiShen3(yuQi + "（食神）");
                }

                /*------------------------正官-----------------------------*/
                String zhengGuanBenQi = (benQi != null) ? shiShenConfig.getZhengGuan().get(benQi) : null; //正官本气
                String zhengGuanZhongQi = (zhongQi != null) ? shiShenConfig.getZhengGuan().get(zhongQi) : null; //正官中气
                String zhengGuanYuQi = (yuQi != null) ? shiShenConfig.getZhengGuan().get(yuQi) : null; //正官 余气

                if (StringUtils.isNotEmpty(zhengGuanBenQi) && list.get(4).getName().equals(zhengGuanBenQi)) { //比对出正官
                    list.get(i).setShiShen1(benQi + "（正官）");
                }
                if (StringUtils.isNotEmpty(zhengGuanZhongQi) && list.get(4).getName().equals(zhengGuanZhongQi)) { //比对出正官
                    list.get(i).setShiShen2(zhongQi + "（正官）");
                }
                if (StringUtils.isNotEmpty(zhengGuanYuQi) && list.get(4).getName().equals(zhengGuanYuQi)) { //比对出正官
                    list.get(i).setShiShen3(yuQi + "（正官）");
                }

                /*------------------------正财-----------------------------*/
                String zhengCaiBenQi = (benQi != null) ? shiShenConfig.getZhengCai().get(benQi) : null; //正财本气
                String zhengCaiZhongQi = (zhongQi != null) ? shiShenConfig.getZhengCai().get(zhongQi) : null; //正财中气
                String zhengCaiYuQi = (yuQi != null) ? shiShenConfig.getZhengCai().get(yuQi) : null; //正财余气

                if (StringUtils.isNotEmpty(zhengCaiBenQi) && list.get(4).getName().equals(zhengCaiBenQi)) { //比对出正财
                    list.get(i).setShiShen1(benQi + "（正财）");
                }
                if (StringUtils.isNotEmpty(zhengCaiZhongQi) && list.get(4).getName().equals(zhengCaiZhongQi)) { //比对出正财
                    list.get(i).setShiShen2(zhongQi + "（正财）");
                }
                if (StringUtils.isNotEmpty(zhengCaiYuQi) && list.get(4).getName().equals(zhengCaiYuQi)) { //比对出正财
                    list.get(i).setShiShen3(yuQi + "（正财）");
                }


                /*------------------------七杀-----------------------------*/
                String qiShaBenQi = (benQi != null) ? shiShenConfig.getQiSha().get(benQi) : null; //七杀本气
                String qiShaZhongQi = (zhongQi != null) ? shiShenConfig.getQiSha().get(zhongQi) : null; //七杀中气
                String qiShaYuQi = (yuQi != null) ? shiShenConfig.getQiSha().get(yuQi) : null; //七杀余气

                if (StringUtils.isNotEmpty(qiShaBenQi) && list.get(4).getName().equals(qiShaBenQi)) { //比对出七杀
                    list.get(i).setShiShen1(benQi + "（七杀）");
                }
                if (StringUtils.isNotEmpty(qiShaZhongQi) && list.get(4).getName().equals(qiShaZhongQi)) { //比对出七杀
                    list.get(i).setShiShen2(zhongQi + "（七杀）");
                }
                if (StringUtils.isNotEmpty(qiShaYuQi) && list.get(4).getName().equals(qiShaYuQi)) { //比对出七杀
                    list.get(i).setShiShen3(yuQi + "（七杀）");
                }


                /*------------------------偏印-----------------------------*/
                String pianYinBenQi = (benQi != null) ? shiShenConfig.getPianYin().get(benQi) : null; //偏印本气
                String pianYinZhongQi = (zhongQi != null) ? shiShenConfig.getPianYin().get(zhongQi) : null; //偏印中气
                String pianYinYuQi = (yuQi != null) ? shiShenConfig.getPianYin().get(yuQi) : null; //偏印余气

                if (StringUtils.isNotEmpty(pianYinBenQi) && list.get(4).getName().equals(pianYinBenQi)) { //比对出七杀
                    list.get(i).setShiShen1(benQi + "（偏印）");
                }
                if (StringUtils.isNotEmpty(pianYinZhongQi) && list.get(4).getName().equals(pianYinZhongQi)) { //比对出七杀
                    list.get(i).setShiShen2(zhongQi + "（偏印）");
                }
                if (StringUtils.isNotEmpty(pianYinYuQi) && list.get(4).getName().equals(pianYinYuQi)) { //比对出七杀
                    list.get(i).setShiShen3(yuQi + "（偏印）");
                }

                /*------------------------伤官-----------------------------*/
                String shangGuanBenQi = (benQi != null) ? shiShenConfig.getShangGuan().get(benQi) : null; //伤官本气
                String shangGuanZhongQi = (zhongQi != null) ? shiShenConfig.getShangGuan().get(zhongQi) : null; //伤官中气
                String shangGuanYuQi = (yuQi != null) ? shiShenConfig.getShangGuan().get(yuQi) : null; //伤官余气

                if (StringUtils.isNotEmpty(shangGuanBenQi) && list.get(4).getName().equals(shangGuanBenQi)) { //比对出伤官
                    list.get(i).setShiShen1(benQi + "（伤官）");
                }
                if (StringUtils.isNotEmpty(shangGuanZhongQi) && list.get(4).getName().equals(shangGuanZhongQi)) { //比对出伤官
                    list.get(i).setShiShen2(zhongQi + "（伤官）");
                }
                if (StringUtils.isNotEmpty(shangGuanYuQi) && list.get(4).getName().equals(shangGuanYuQi)) { //比对出伤官
                    list.get(i).setShiShen3(yuQi + "（伤官）");
                }


                /*------------------------劫财-----------------------------*/
                String jieCaiBenQi = (benQi != null) ? shiShenConfig.getJieCai().get(benQi) : null; //劫财本气
                String jieCaiZhongQi = (zhongQi != null) ? shiShenConfig.getJieCai().get(zhongQi) : null; //劫财中气
                String jieCaiYuQi = (yuQi != null) ? shiShenConfig.getJieCai().get(yuQi) : null; //劫财余气

                if (StringUtils.isNotEmpty(jieCaiBenQi) && list.get(4).getName().equals(jieCaiBenQi)) { //比对出劫财
                    list.get(i).setShiShen1(benQi + "（劫财）");
                }
                if (StringUtils.isNotEmpty(jieCaiZhongQi) && list.get(4).getName().equals(jieCaiZhongQi)) { //比对出劫财
                    list.get(i).setShiShen2(zhongQi + "（劫财）");
                }
                if (StringUtils.isNotEmpty(jieCaiYuQi) && list.get(4).getName().equals(jieCaiYuQi)) { //比对出劫财
                    list.get(i).setShiShen3(yuQi + "（劫财）");
                }

                /*------------------------比肩-----------------------------*/
                String biJianBenQi = (benQi != null) ? shiShenConfig.getBiJian().get(benQi) : null; //比肩本气
                String biJianZhongQi = (zhongQi != null) ? shiShenConfig.getBiJian().get(zhongQi) : null; //比肩中气
                String biJianYuQi = (yuQi != null) ? shiShenConfig.getBiJian().get(yuQi) : null; //比肩余气

                if (StringUtils.isNotEmpty(biJianBenQi) && list.get(4).getName().equals(biJianBenQi)) {
                    list.get(i).setShiShen1(benQi + "（比肩）");
                }
                if (StringUtils.isNotEmpty(biJianZhongQi) && list.get(4).getName().equals(biJianZhongQi)) {
                    list.get(i).setShiShen2(zhongQi + "（比肩）");
                }
                if (StringUtils.isNotEmpty(biJianYuQi) && list.get(4).getName().equals(biJianYuQi)) {
                    list.get(i).setShiShen3(yuQi + "（比肩）");
                }

                /*------------------------偏财-----------------------------*/
                String pianCaiBenQi = (benQi != null) ? shiShenConfig.getPianCai().get(benQi) : null; //偏财本气
                String pianCaiZhongQi = (zhongQi != null) ? shiShenConfig.getPianCai().get(zhongQi) : null; //偏财中气
                String pianCaiYuQi = (yuQi != null) ? shiShenConfig.getPianCai().get(yuQi) : null; //偏财余气

                if (StringUtils.isNotEmpty(pianCaiBenQi) && list.get(4).getName().equals(pianCaiBenQi)) { //比对出偏财
                    list.get(i).setShiShen1(benQi + "（偏财）");
                }
                if (StringUtils.isNotEmpty(pianCaiZhongQi) && list.get(4).getName().equals(pianCaiZhongQi)) { //比对出偏财
                    list.get(i).setShiShen2(zhongQi + "（偏财）");
                }
                if (StringUtils.isNotEmpty(pianCaiYuQi) && list.get(4).getName().equals(pianCaiYuQi)) { //比对出偏财
                    list.get(i).setShiShen3(yuQi + "（偏财）");
                }

            }


        }
        /*-----------------------十神 结束-------------------*/


        return list;
    }


    @Override
    public List<GanZhiNaYinVo> selectGanZhiNaYinList(GanZhiDto ganZhiDto) {

        String yearZhuNaYinKey = ganZhiDto.getYearGan() + ganZhiDto.getYearZhi();
        String monthZhuNaYinKey = ganZhiDto.getMonthGan() + ganZhiDto.getMonthZhi();
        String dayZhuNaYinKey = ganZhiDto.getDayGan() + ganZhiDto.getDayZhi();
        String timeZhuNaYinKey = ganZhiDto.getTimeGan() + ganZhiDto.getTimeZhi();

        String yearZhuNaYin = shiShenConfig.getNaYin().get(yearZhuNaYinKey);
        String monthZhuNaYin = shiShenConfig.getNaYin().get(monthZhuNaYinKey);
        String dayZhuNaYin = shiShenConfig.getNaYin().get(dayZhuNaYinKey);
        String timeZhuNaYin = shiShenConfig.getNaYin().get(timeZhuNaYinKey);

        GanZhiNaYinVo yearNaYinVo = new GanZhiNaYinVo();
        yearNaYinVo.setZhu("年");
        yearNaYinVo.setNaYin(yearZhuNaYin);
        GanZhiNaYinVo monthNaYinVo = new GanZhiNaYinVo();
        monthNaYinVo.setZhu("月");
        monthNaYinVo.setNaYin(monthZhuNaYin);
        GanZhiNaYinVo dayNaYinVo = new GanZhiNaYinVo();
        dayNaYinVo.setZhu("日");
        dayNaYinVo.setNaYin(dayZhuNaYin);
        GanZhiNaYinVo timeNaYinVo = new GanZhiNaYinVo();
        timeNaYinVo.setZhu("时");
        timeNaYinVo.setNaYin(timeZhuNaYin);

        List<GanZhiNaYinVo> list = new ArrayList<GanZhiNaYinVo>();
        list.add(yearNaYinVo);
        list.add(monthNaYinVo);
        list.add(dayNaYinVo);
        list.add(timeNaYinVo);
        return list;
    }


    @Override
    public List<GanZhiKongWangVo> selectGanZhiKongWangList(GanZhiDto ganZhiDto) {

        String yearZhuKongWangKey = ganZhiDto.getYearGan() + ganZhiDto.getYearZhi();
        String monthZhuKongWangKey = ganZhiDto.getMonthGan() + ganZhiDto.getMonthZhi();
        String dayZhuNaKongWangKey = ganZhiDto.getDayGan() + ganZhiDto.getDayZhi();
        String timeZhuNaKongWangKey = ganZhiDto.getTimeGan() + ganZhiDto.getTimeZhi();

        String yearZhuKongWang = shiShenConfig.getKongWang().get(yearZhuKongWangKey);
        String monthZhuKongWang = shiShenConfig.getKongWang().get(monthZhuKongWangKey);
        String dayZhuKongWang = shiShenConfig.getKongWang().get(dayZhuNaKongWangKey);
        String timeZhuKongWang = shiShenConfig.getKongWang().get(timeZhuNaKongWangKey);

        GanZhiKongWangVo yearKongWangVo = new GanZhiKongWangVo();
        yearKongWangVo.setZhu("年");
        yearKongWangVo.setKongWang(yearZhuKongWang);
        GanZhiKongWangVo monthKongWangVo = new GanZhiKongWangVo();
        monthKongWangVo.setZhu("月");
        monthKongWangVo.setKongWang(monthZhuKongWang);
        GanZhiKongWangVo dayKongWangVo = new GanZhiKongWangVo();
        dayKongWangVo.setZhu("日");
        dayKongWangVo.setKongWang(dayZhuKongWang);
        GanZhiKongWangVo timeKongWangVo = new GanZhiKongWangVo();
        timeKongWangVo.setZhu("时");
        timeKongWangVo.setKongWang(timeZhuKongWang);

        List<GanZhiKongWangVo> list = new ArrayList<GanZhiKongWangVo>();
        list.add(yearKongWangVo);
        list.add(monthKongWangVo);
        list.add(dayKongWangVo);
        list.add(timeKongWangVo);
        return list;
    }

    @Override
    public Integer getRiYuanQr(GanZhiDto ganZhiDto) {
        /*-------------------日元身强身弱---------------------*/
        List<GanZhiRowVo> list = this.getGanZhiRowVoList(ganZhiDto);
        int yearGanQR = ShiShenConfig.generateRelationship(list.get(4).getFive(), list.get(0).getFive());
        int yearZhiQR = ShiShenConfig.generateRelationship(list.get(4).getFive(), list.get(1).getFive());
        int monthGanQR = ShiShenConfig.generateRelationship(list.get(4).getFive(), list.get(2).getFive());
        int monthZhiQR = ShiShenConfig.generateRelationship(list.get(4).getFive(), list.get(3).getFive());
        //     int dayGanQR = ShiShenConfig.generateRelationship(list.get(4).getFive(),list.get(4).getFive());
        int dayZhiQR = ShiShenConfig.generateRelationship(list.get(4).getFive(), list.get(5).getFive());
        int timeGanQR = ShiShenConfig.generateRelationship(list.get(4).getFive(), list.get(6).getFive());
        int timeZhiQR = ShiShenConfig.generateRelationship(list.get(4).getFive(), list.get(7).getFive());

        int score = 0;
        if (yearGanQR > 0) {
            score += 8;
        }
        if (yearZhiQR > 0) {
            score += 4;
        }
        if (monthGanQR > 0) {
            score += 12;
        }
        if (monthZhiQR > 0) {
            score += 40;
        }
        if (dayZhiQR > 0) {
            score += 12;
        }
        if (timeGanQR > 0) {
            score += 12;
        }
        if (timeZhiQR > 0) {
            score += 12;
        }

        List<String> xiYong = null;
        if (score > 50) {
            String fiveQr = list.get(4).getFive() + "强";
            xiYong = shiShenConfig.getXiYong().get(fiveQr);
        } else {
            String fiveQr = list.get(4).getFive() + "弱";
            xiYong = shiShenConfig.getXiYong().get(fiveQr);
        }
        String xi1 = xiYong.get(0);
        String xi2 = xiYong.get(1);


        Map<String,Integer> fiveCountMap = this.getGanZhiRowVoCount(ganZhiDto);
        int xi1Count = fiveCountMap.get(xi1);
        int xi2Count = fiveCountMap.get(xi2);

        if(xi1Count>3){
            xiYong.remove(xi1);
        }
        if(xi2Count>3){
            xiYong.remove(xi2);
        }

        System.out.println("喜用：" + xiYong);




        return score;
    }


    /**
     * 干支组装
     *
     * @param ganZhiDto
     * @return
     */
    private List<GanZhiRowVo> getGanZhiRowVoList(GanZhiDto ganZhiDto) {

        String yearGanFive = shiShenConfig.getGanZhiFive().get(ganZhiDto.getYearGan());
        String yearZhiFive = shiShenConfig.getGanZhiFive().get(ganZhiDto.getYearZhi());
        String monthGanFive = shiShenConfig.getGanZhiFive().get(ganZhiDto.getMonthGan());
        String monthZhiFive = shiShenConfig.getGanZhiFive().get(ganZhiDto.getMonthZhi());
        String dayGanFive = shiShenConfig.getGanZhiFive().get(ganZhiDto.getDayGan());
        String dayZhiFive = shiShenConfig.getGanZhiFive().get(ganZhiDto.getDayZhi());
        String timeGanFive = shiShenConfig.getGanZhiFive().get(ganZhiDto.getTimeGan());
        String timeZhiFive = shiShenConfig.getGanZhiFive().get(ganZhiDto.getTimeZhi());


        String yearGanColor = shiShenConfig.getGanZhiColor().get(ganZhiDto.getYearGan());
        String yearZhiColor = shiShenConfig.getGanZhiColor().get(ganZhiDto.getYearZhi());
        String monthGanColor = shiShenConfig.getGanZhiColor().get(ganZhiDto.getMonthGan());
        String monthZhiColor = shiShenConfig.getGanZhiColor().get(ganZhiDto.getMonthZhi());
        String dayGanColor = shiShenConfig.getGanZhiColor().get(ganZhiDto.getDayGan());
        String dayZhiColor = shiShenConfig.getGanZhiColor().get(ganZhiDto.getDayZhi());
        String timeGanColor = shiShenConfig.getGanZhiColor().get(ganZhiDto.getTimeGan());
        String timeZhiColor = shiShenConfig.getGanZhiColor().get(ganZhiDto.getTimeZhi());

        GanZhiRowVo yearGan = new GanZhiRowVo();
        yearGan.setGongWei("年干");
        yearGan.setFive(yearGanFive);
        yearGan.setColor(yearGanColor);
        yearGan.setName(ganZhiDto.getYearGan());

        GanZhiRowVo yearZhi = new GanZhiRowVo();
        yearZhi.setGongWei("年支");
        yearZhi.setFive(yearZhiFive);
        yearZhi.setColor(yearZhiColor);
        yearZhi.setName(ganZhiDto.getYearZhi());

        GanZhiRowVo monthGan = new GanZhiRowVo();
        monthGan.setGongWei("月干");
        monthGan.setFive(monthGanFive);
        monthGan.setColor(monthGanColor);
        monthGan.setName(ganZhiDto.getMonthGan());


        GanZhiRowVo monthZhi = new GanZhiRowVo();
        monthZhi.setGongWei("月支");
        monthZhi.setFive(monthZhiFive);
        monthZhi.setColor(monthZhiColor);
        monthZhi.setName(ganZhiDto.getMonthZhi());

        GanZhiRowVo dayGan = new GanZhiRowVo();
        dayGan.setGongWei("日干");
        dayGan.setFive(dayGanFive);
        dayGan.setColor(dayGanColor);
        dayGan.setName(ganZhiDto.getDayGan());


        GanZhiRowVo dayZhi = new GanZhiRowVo();
        dayZhi.setGongWei("日支");
        dayZhi.setFive(dayZhiFive);
        dayZhi.setColor(dayZhiColor);
        dayZhi.setName(ganZhiDto.getDayZhi());

        GanZhiRowVo timeGan = new GanZhiRowVo();
        timeGan.setGongWei("时干");
        timeGan.setFive(timeGanFive);
        timeGan.setColor(timeGanColor);
        timeGan.setName(ganZhiDto.getTimeGan());

        GanZhiRowVo timeZhi = new GanZhiRowVo();
        timeZhi.setGongWei("时支");
        timeZhi.setFive(timeZhiFive);
        timeZhi.setColor(timeZhiColor);
        timeZhi.setName(ganZhiDto.getDayZhi());

        List<GanZhiRowVo> list = new ArrayList<GanZhiRowVo>();
        list.add(yearGan);
        list.add(yearZhi);
        list.add(monthGan);
        list.add(monthZhi);
        list.add(dayGan);
        list.add(dayZhi);
        list.add(timeGan);
        list.add(timeZhi);

        return list;
    }

    /**
     * 获取五行数量
     * @param ganZhiDto
     * @return
     */
    @Override
    public Map<String,Integer> getGanZhiRowVoCount(GanZhiDto ganZhiDto) {

        Map<String,Integer> fiveCount = new TreeMap<String,Integer>();
        fiveCount.put("木",0);
        fiveCount.put("火",0);
        fiveCount.put("土",0);
        fiveCount.put("金",0);
        fiveCount.put("水",0);

        List<GanZhiRowVo> list = this.getGanZhiRowVoList(ganZhiDto);
        for (int i = 0; i < list.size() ; i++) {
            String five = list.get(i).getFive();
            Integer fiveC = fiveCount.get(five)+1;
            fiveCount.put(five,fiveC);
        }
        return fiveCount;
    }

}